use serde::Deserialize;
use serde::Serialize;

pub type WebSocketMessage = State;

#[derive(Default, Clone, Debug, Serialize, Deserialize, PartialEq, Eq)]
pub struct State {
    pub achievements: Vec<Achievement>,
}

#[derive(Clone, Debug, Serialize, Deserialize, PartialEq, Eq)]
pub struct Achievement {
    pub goal: String,
    pub completed: bool,
    pub uuid: uuid::Uuid,
}

#[derive(Debug, Clone, Serialize, Deserialize)]
pub struct CreateAchievement {
    pub goal: String,
}

#[derive(Debug, Clone, Serialize, Deserialize)]
pub struct ToggleAchievement {
    pub uuid: uuid::Uuid,
}

#[derive(Debug, Serialize, Clone, Deserialize)]
pub struct DeleteAchievement {
    pub uuid: uuid::Uuid,
}
